/*************************************************************
 *
 * PlotForm.h: The following public procedures are defined for
 * creating forms for axis information choice by the user.
 *
 *************************************************************/

typedef struct {
  int place, type;
  char *title;
  double min;
  double max;
  double paperSpeed;
  char *units;
  int autoScale;
  int stripMode;
} *AxisData, AxisDataRec;

/* Create a menu to choose axes for a new plot, user supplied create routine */
extern Widget MakePlotMenu(); /* parent, widgetClass, x, y, circuitDiagram 
			         AxisData X, 1, 2, 3 pointers may be NULL */

extern void replaceText();
