#ifndef lint
static char *rcs="$Header: /afs/athena.mit.edu/course/other/hst/src/nl/RCS/Input.c,v 2.2 97/01/30 14:17:59 dot Exp $";
#endif
/********************************************************
 * Input widget is a shell of a widget, does nothing but
 * create a window of type InputOnly.
 * $Source: /afs/athena.mit.edu/course/other/hst/src/nl/RCS/Input.c,v $
 * $Log:	Input.c,v $
 * Revision 2.2  97/01/30  14:17:59  dot
 * Should be sizeof(InputRec), not InputClassRec
 * 
 * Revision 2.1  90/08/10  16:14:19  tldavis
 * Added a line to the SimplePart declaration for X11R4.
 * 
 * Revision 2.0  90/08/06  17:57:29  tldavis
 * Final X11R3 version.
 * 
 * Revision 1.4  89/02/22  12:26:20  tldavis
 * X11R3 version.
 * 
 * Revision 1.3  88/08/23  11:19:15  tldavis
 * Cleaned up header file references.
 * 
 ********************************************************/
#include <stdio.h>
#include <X11/IntrinsicP.h>
#include <X11/StringDefs.h>
#include "InputP.h"

/*ARGSUSED*/ static void InputOnlyRealize(w,mask,attributes)
     Widget w;
     Mask *mask; /* unused */
     XSetWindowAttributes *attributes;
{
  Mask InputMask = CWWinGravity | CWEventMask | CWDontPropagate | 
                   CWOverrideRedirect | CWCursor;
  w->core.border_width = 0;
  w->core.depth = 0; /* InputOnly window MUST have these == 0 */
  XtCreateWindow(w, (unsigned int)InputOnly, (Visual *) CopyFromParent, 
		 (Mask)(*mask & InputMask) , attributes);
}

static XtResource resources[] = {
};

InputClassRec inputClassRec = {
  { /* superclass		*/	(WidgetClass) &simpleClassRec,
    /* class_name		*/	"Input",
    /* widget_size		*/	sizeof(InputRec),
    /* class_initialize		*/	NULL,
    /* class_part_initialize	*/	NULL,
    /* class_inited		*/	FALSE,
    /* initialize		*/	NULL,
    /* initialize_hook		*/	NULL,
    /* realize			*/	InputOnlyRealize,
    /* actions			*/	NULL,
    /* num_actions		*/	0,
    /* resources		*/      resources,
    /* num_resources		*/	XtNumber(resources),
    /* xrm_class		*/	NULLQUARK,
    /* compress_motion		*/	TRUE,
    /* compress_exposure	*/	TRUE,
    /* compress_enterleave	*/	TRUE,
    /* visible_interest		*/	FALSE,
    /* destroy			*/	NULL,
    /* resize			*/	XtInheritResize,
    /* expose			*/	NULL,
    /* set_values		*/	NULL,
    /* set_values_hook		*/	NULL,
    /* set_values_almost	*/	XtInheritSetValuesAlmost,
    /* get_values_hook		*/	NULL,
    /* accept_focus		*/	NULL,
    /* version			*/	XtVersion,
    /* callback_private		*/	NULL,
    /* tm_table			*/	NULL,
    /* query_geometry		*/	XtInheritQueryGeometry,
    /* NEW R3 display_accellerator*/    XtInheritDisplayAccelerator,
    /* NEW R3 extension */              NULL,
  },
  { /* Simple fields */ 
#ifndef XAW_BC
    /* NEW R4 change_sensitive */       XtInheritChangeSensitive, 
#else /* no XAW_BC */
					0,
#endif
  },
  { /* Input fields  */ 0, },
};
WidgetClass inputWidgetClass = (WidgetClass) &inputClassRec;





