#ifndef _InputP_h
#define _InputP_h
/***********************************************************************
 * $Header: /mit/hst/src/nl/RCS/InputP.h,v 2.1 90/08/10 10:58:49 dot Exp $
 * $Source: /mit/hst/src/nl/RCS/InputP.h,v $
 *
 * Input Widget Private Data Definitions
 *
 ***********************************************************************/

#include <X11/Xaw/SimpleP.h>

typedef struct {
  int foo;
} InputClassPart;

typedef struct _InputClassRec {
  CoreClassPart        core_class;
  SimpleClassPart      simple_class;
  InputClassPart       input_class;
} InputClassRec;

extern InputClassRec inputClassRec;
extern WidgetClass   inputWidgetClass;

typedef struct {
  int foo;
} InputPart;


/****************************************************************
 *
 * Full instance record declaration
 *
 ****************************************************************/

typedef struct _InputRec {
    CorePart	core;
    SimplePart  simple;
    InputPart   input;
} InputRec, *InputWidget;

#endif


